package com.example.lede2;

import android.content.Context;
import android.os.Bundle;
import android.support.v7.app.AppCompatActivity;
import android.view.View;
import android.view.inputmethod.InputMethodManager;
import android.widget.Button;
import android.widget.EditText;
import android.widget.TextView;

public class DeleteDeviceActivity extends AppCompatActivity implements View.OnClickListener, View.OnFocusChangeListener {

    Button deleteButton;
    Button doneButton;
    EditText device_id;
    EditText device_type;
    EditText device_subtype;
    EditText device_address_subtype;
    TextView status;
    private SSH_MySQL ssh;//Connection object between Android & Host

    @Override
    protected void onCreate(Bundle savedInstanceState) {
        super.onCreate(savedInstanceState);
        setContentView(R.layout.activity_delete_device);

        deleteButton = (Button) findViewById(R.id.delete);
        doneButton = (Button) findViewById(R.id.done);
        device_id = (EditText)findViewById(R.id.device_id);
        device_type = (EditText)findViewById(R.id.device_type);
        device_subtype = (EditText)findViewById(R.id.device_subtype);
        device_address_subtype = (EditText)findViewById(R.id.device_address_subtype);
        status = (TextView)findViewById(R.id.textStatus);

        deleteButton.setOnClickListener(this);
        doneButton.setOnClickListener(this);
        device_id.setOnFocusChangeListener(this);
        device_type.setOnFocusChangeListener(this);
        device_subtype.setOnFocusChangeListener(this);
        device_address_subtype.setOnFocusChangeListener(this);
        ssh = new SSH_MySQL();
    }

    @Override
    public void onClick(View v) {
        if(v == deleteButton){
            // Remove the entry based on ID, type, and subtype
            ssh.execute(MainActivity.DEF_DELETE_CMD + " " +
                    device_id.getText().toString() + " " +
                    device_type.getText().toString() + " " +
                    device_subtype.getText().toString() + ";" +
                    // Also remove the device address
                    MainActivity.DEF_DELETE_ADDRESS_CMD + " " +
                    device_id.getText().toString() + " " +
                    device_address_subtype.getText().toString()
            );
            device_id.setText("");
            device_type.setText("");
            device_subtype.setText("");
            device_address_subtype.setText("");
            status.setText("Successfully deleted " + device_id.getText());
            /*try {
                Thread.sleep(2000);
            } catch (Exception ex) {
                ex.printStackTrace();
            }
            status.setText("");*/
        }
        if(v == doneButton){
            finish();
        }

    }

    @Override
    public void onFocusChange(View view, boolean hasFocus) {
        InputMethodManager imm = (InputMethodManager) getSystemService(Context.INPUT_METHOD_SERVICE);
        if (hasFocus) {
            imm.toggleSoftInput(InputMethodManager.SHOW_FORCED, 0);
        } else {
            imm.hideSoftInputFromWindow(view.getWindowToken(), 0);
        }
    }
}
