package com.example.lede2;

import android.content.Intent;
import android.support.v7.app.AppCompatActivity;
import android.os.Bundle;
import android.util.Log;
import android.util.SparseBooleanArray;
import android.view.View;
import android.widget.AdapterView;
import android.widget.ArrayAdapter;
import android.widget.Button;
import android.widget.EditText;
import android.widget.ListView;
import android.widget.TextView;
import android.widget.Toast;

import java.util.List;

public class ListActivity extends AppCompatActivity implements View.OnClickListener {

    Button delete;//delete button in UI
    Button deviceInfo;//select button in UI
    ListView listview;//listview in UI
    SSH ssh;//Connection object between Android & Router
    List<String> tmp;//data structure which has IoT device information already registered on LEDE2
    ArrayAdapter adapter;//adapter between tmp and listview
    String device_info;
    protected String deviceIp;
    TextView ip;
    TextView mac;

    @Override
    protected void onCreate(Bundle savedInstanceState) {
        super.onCreate(savedInstanceState);
        setContentView(R.layout.activity_list);

        ssh = new SSH();
        try {
            tmp = ssh.execute("-ln").get();
            Thread.sleep(1000);//To execute asyntask in ssh object, we have to sleep main thread
        } catch (Exception e) {
        }

        delete = (Button) findViewById(R.id.delete);
        deviceInfo = (Button) findViewById(R.id.deviceInfo);
        listview = (ListView) findViewById(R.id.listView1);
        ip = (TextView) findViewById(R.id.txt_ip);
        mac = (TextView) findViewById(R.id.txt_mac);

        adapter = new ArrayAdapter(this, android.R.layout.simple_list_item_multiple_choice, tmp);//register tmp array to adapter

        delete.setOnClickListener(this);
        deviceInfo.setOnClickListener(this);
        listview.setAdapter(adapter);
        listview.setOnItemClickListener(new AdapterView.OnItemClickListener() {
            public void onItemClick(AdapterView<?> parent, View view, int position, long id) {
                device_info = listview.getItemAtPosition(position).toString();
        }});
    }

    @Override
    public void onClick(View v) {
        if (v == delete) {
            //SparseBooleanArray's data is Ture or False
            SparseBooleanArray checkedItems = listview.getCheckedItemPositions();//to check which devices are checked in listview(check -> true, no check -> false)
            int count = adapter.getCount();//number of items in listview
            String command = "-dn "; //after, +'name '

            for (int i = count - 1; i >= 0; i--) {//scan from back
                //i : index of IoT device which will be removed in tmp array
                if (checkedItems.get(i)) {//if check
                    String rmName = tmp.get(i).toString();//save the name of checked IoT device
                    command += rmName + " ";//complete command
                    //remove this information on the listview
                    tmp.remove(i);
                    //deviceIp = checkedItems.
                }
            }
            try {
                //delete IoT device information in the router by sending command line to router
                ssh = new SSH();
                ssh.execute(command);
                Thread.sleep(1000);//To execute asyntask in ssh object, we have to sleep main thread
            } catch (Exception e) {
                Log.d("SLEEP EXCEPTION", "SLEEP EXCEPTION occurs in onClick method of ListActivity");
            }
            //update
            adapter.notifyDataSetChanged();
            //delete checked mark in listview
            listview.clearChoices();

        } else if (v == deviceInfo) {
            String[] devInfo = device_info.split("\\s+");
            ip.setText(devInfo[1]);
            mac.setText(devInfo[2]);
            Toast t = Toast.makeText(this, device_info, Toast.LENGTH_SHORT);
            t.show();
            /*} else if (v == selectAll) {
            int count;
            count = adapter.getCount();

            for (int i = 0; i < count; i++) {
                listview.setItemChecked(i, true);
            }*/
        }
    }
}
