package com.example.lede2;

import android.content.Context;
import android.content.Intent;
import android.net.ConnectivityManager;
import android.net.NetworkInfo;
import android.net.wifi.WifiManager;
import android.support.v7.app.AppCompatActivity;
import android.os.Bundle;
import android.util.Log;
import android.view.View;
import android.widget.Button;
import android.widget.TextView;
import android.widget.Toast;

public class MainActivity extends AppCompatActivity implements View.OnClickListener {

    Button registerButton;
    Button listButton;
    Button insertDBButton;
    Button deleteDBButton;
    Button configButton;
    Button relationButton;
    TextView ssid;
    protected static Context context;
    protected static String DEF_RSSID;
    protected static String DEF_RPWD;
    protected static String DEF_ROUTERIP;
    protected static String DEF_ROUTERUSER;
    protected static String DEF_MYSQLHOSTUSER;
    protected static String DEF_MYSQLHOSTIP;
    protected static String DEF_MYSQLHOSTPASSWORD;
    protected static String DEF_CHANGE_DEFAULT_SCRIPT;
    protected static String DEF_CONNECT_DEVICE_SCRIPT;
    protected static String DEF_REGISTER_DEVICE_SCRIPT;
    protected static String DEF_ADD_DEVICE_FILE;
    protected static String DEF_ADD_DEVICE_ADDRESS_FILE;
    protected static String DEF_ADD_DEVICE_COMM_FILE;
    protected static String DEF_ADD_DEVICE_TO_MYSQL;
    protected static String DEF_MYSQL_CONFIG_FILE;
    protected static String DEF_INSTALL_CMD;
    protected static String DEF_DELETE_CMD;
    protected static String DEF_INSTALL_ADDRESS_CMD;
    protected static String DEF_DELETE_ADDRESS_CMD;
    protected static String DEF_INSTALL_RELATION_CMD;
    protected static String DEF_DELETE_RELATION_CMD;

    @Override
    protected void onCreate(Bundle savedInstanceState) {
        super.onCreate(savedInstanceState);
        setContentView(R.layout.activity_main);

        registerButton = (Button) findViewById(R.id.register);
        listButton = (Button) findViewById(R.id.list);
        insertDBButton = (Button) findViewById(R.id.insert_db);
        deleteDBButton = (Button) findViewById(R.id.delete_db);
        configButton = (Button) findViewById(R.id.config);
        relationButton = (Button) findViewById(R.id.add_del_comm);
        ssid = (TextView)findViewById(R.id.device_subtype);

        registerButton.setOnClickListener(this);
        listButton.setOnClickListener(this);
        insertDBButton.setOnClickListener(this);
        deleteDBButton.setOnClickListener(this);
        configButton.setOnClickListener(this);
        relationButton.setOnClickListener(this);

        context = getApplicationContext();
        DEF_RSSID = context.getResources().getString(R.string.default_rssid);
        DEF_RPWD = context.getResources().getString(R.string.default_rpwd);
        DEF_ROUTERIP = context.getResources().getString(R.string.default_routerip);
        DEF_ROUTERUSER = context.getResources().getString(R.string.default_routeruser);
        DEF_CHANGE_DEFAULT_SCRIPT = context.getResources().getString(R.string.change_default_script);
        DEF_CONNECT_DEVICE_SCRIPT = context.getResources().getString(R.string.connect_device_script);
        DEF_REGISTER_DEVICE_SCRIPT = context.getResources().getString(R.string.register_device_script);
        DEF_ADD_DEVICE_FILE = context.getResources().getString(R.string.add_device_file);
        DEF_ADD_DEVICE_ADDRESS_FILE = context.getResources().getString(R.string.add_device_address_file);
        DEF_ADD_DEVICE_COMM_FILE = context.getResources().getString(R.string.add_device_comm_file);
        DEF_MYSQLHOSTUSER = context.getResources().getString(R.string.mysql_hostuser);
        DEF_MYSQLHOSTIP = context.getResources().getString(R.string.mysql_hostip);
        DEF_MYSQLHOSTPASSWORD = context.getResources().getString(R.string.mysql_hostpassword);
        DEF_ADD_DEVICE_TO_MYSQL = context.getResources().getString(R.string.add_device_to_mysql);
        DEF_MYSQL_CONFIG_FILE = context.getResources().getString(R.string.mysql_config_file);
        DEF_INSTALL_CMD = context.getResources().getString(R.string.install_cmd);
        DEF_DELETE_CMD = context.getResources().getString(R.string.delete_cmd);
        DEF_INSTALL_ADDRESS_CMD = context.getResources().getString(R.string.install_address_cmd);
        DEF_DELETE_ADDRESS_CMD = context.getResources().getString(R.string.delete_address_cmd);
        DEF_INSTALL_RELATION_CMD = context.getResources().getString(R.string.add_comm_cmd);
        DEF_DELETE_RELATION_CMD = context.getResources().getString(R.string.delete_comm_cmd);
        ssid.setText(DEF_RSSID);
    }

    public void onClick(View v) {

        if(v == configButton){
            startActivityForResult(new Intent(this,ConfigActivity.class),1000);
        }

        //Users try to execute shell scripts by pushing button,
        //but problem could occur(application stop) if user push the button without wifi connection
        //As a result, below function have to be implemented.
        if (isNetworkAvailable() == false) {//without wifi connection
            Toast t = Toast.makeText(this, R.string.connect, Toast.LENGTH_SHORT);
            t.show();
            startActivity(new Intent(WifiManager.ACTION_PICK_WIFI_NETWORK));
        } else {//with wifi connection
            if (v == registerButton) {
                Log.d("CLICKING", "Clicking on register!");
                startActivity(new Intent(this, EnrollDeviceActivity.class));
                //startActivity(new Intent(this, AddDeviceActivity.class));
            } else if (v == listButton) {
                Log.d("CLICKING", "Clicking on list activity!");
                startActivity(new Intent(this, ListActivity.class));
            } else if (v == insertDBButton) {
                Log.d("CLICKING", "Clicking on add device!");
                startActivity(new Intent(this, AddDeviceActivity.class));
            } else if (v == deleteDBButton) {
                Log.d("CLICKING", "Clicking on delete device!");
                startActivity(new Intent(this, DeleteDeviceActivity.class));
            } else if (v == relationButton) {
                Log.d("CLICKING", "Clicking on add communication!");
                startActivity(new Intent(this, RelationActivity.class));
            }
        }
    }

    boolean isNetworkAvailable() {//check whether wifi connection is or not
        Context context = getApplicationContext();
        ConnectivityManager cm = (ConnectivityManager) context.getSystemService(Context.CONNECTIVITY_SERVICE);
        NetworkInfo activeNetwork = cm.getActiveNetworkInfo();
        boolean isConnected = activeNetwork != null && activeNetwork.isConnectedOrConnecting();
        return isConnected;
    }

    @Override
    protected void onActivityResult(int requestCode, int resultCode, Intent data) {
        super.onActivityResult(requestCode, resultCode, data);

        if(requestCode == 1000){
            ssid.setText(ConfigActivity.RSSID);
        }
    }
}
