#!/bin/bash
# Generated profile for device 192.168.0.4 - Hostname: DCH-S220
ipt=/sbin/iptables
ips=/sbin/ipset

$ipt -N IN_192.168.0.4 # creates a new chain for incoming traffic
$ipt -A FORWARD -d 192.168.0.4 -j IN_192.168.0.4 # filter for incoming traffic
$ipt -A IN_192.168.0.4 -m state --state ESTABLISHED,RELATED -j ACCEPT # accept established connections
$ipt -A IN_192.168.0.4 -p icmp -j ACCEPT # accept incoming ICMP

$ipt -A IN_192.168.0.4 -p tcp --dport 80 -j ACCEPT # allow traffic on tcp/80

$ipt -A IN_192.168.0.4 -j DROP # drop unmatched traffic


$ipt -N OUT_192.168.0.4 # creates a new chain for outgoing traffic
$ipt -A FORWARD -s 192.168.0.4 -j OUT_192.168.0.4 # filter for outgoing traffic
$ipt -A OUT_192.168.0.4 -m state --state ESTABLISHED,RELATED -j ACCEPT # accept established connections
$ipt -A OUT_192.168.0.4 -d 192.168.0.1 -p udp --dport 67 -j ACCEPT # allow traffic to 192.168.0.1:udp/67

$ipt -A OUT_192.168.0.4 -d 52.35.17.196 -p tcp --dport 443 -j ACCEPT # allow traffic to 52.35.17.196:tcp/443

$ipt -A OUT_192.168.0.4 -d 8.8.8.8 -p udp --dport 53 -j ACCEPT # allow traffic to 8.8.8.8:udp/53

$ips create set_24ca1777 hash:ip # create ipset, where dnsmasq will add resolved ips for host name
#echo "ipset=/api.dch.dlink.com/set_24ca1777" >> /etc/dnsmasq.d/192.168.0.4.conf
$ipt -A OUT_192.168.0.4 -m set --match-set set_24ca1777 dst -p tcp --dport 443 -j ACCEPT # allow traffic to api.dch.dlink.com.:tcp/443

$ipt -A OUT_192.168.0.4 -j DROP # drop unmatched traffic
